<template>
  <div class="gallery--container">
    <img
      :src="img"
      width="150"
      height="150"
      :key="index"
      v-for="(img, index) in images"
      @click="previewImage(index)"
    />
  </div>
</template>
<script>
import firebase from "firebase";
export default {
  name: "ImageGallery",
  props: ["upload"],
  data() {
    return {
      images: []
    };
  },
  watch: {
    upload: {
      immediate: true,
      handler(newVal) {
        if (newVal) {
          this.getImages();
        }
      }
    }
  },
  methods: {
    /**
     * Get the images from firebase
     */
    getImages() {
      let self = this;
      const storageRef = firebase.storage().ref(`/images`);
      self.images = [];
      storageRef
        .listAll()
        .then(function(res) {
          res.items.forEach(itemRef => {
            itemRef.getDownloadURL().then(url => {
              self.images.push(url);
            });
          });
        })
        .catch(function(error) {
          console.log(error);
        });
    },
    /**
     * Trigger the image change to preview component
     * @param{number} index from image selected
     */
    previewImage(index) {
      this.$emit("select-image", this.images[index]);
    }
  },
  mounted() {
    this.getImages();
  }
};
</script>
<style lang="scss">
.gallery--container {
  display: grid;
  grid-template-columns: repeat(5, 1fr);
  grid-row-gap: 10px;
  grid-column-gap: 10px;
  align-items: center;
  cursor: pointer;
  img {
    margin: 0 5px;
  }
}
</style>